#include <windows.h>
#include <stdio.h>
#include "cmpcode.h"

#pragma comment(lib, "cmpcode.lib")

#define MYWNDCLASS	"MYWNDCLASS"
#define MYWNDTITLE	"MYWNDTITLE"

char *g_pData = NULL;

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				NULL,
				NULL,
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		if(__argc > 1){
			int type = 2;
			int key = 12345;
			char fileDst[MAX_PATH];
			strncpy(fileDst, __argv[0], sizeof(fileDst));
			char *p = strrchr(fileDst, '\\');
			strcpy(p + 1, "encode");
			Encode_File(type, key, fileDst, __argv[1]);
			int size = Get_FileSize(type, fileDst);
			g_pData = (char*) malloc(size);
			if(g_pData){
				ZeroMemory(g_pData, size);
				Decode_File(type, key, (BYTE*) g_pData, size, fileDst);
				InvalidateRect(hWnd, NULL, FALSE);
			}
		}
		return 0;
	case WM_PAINT:
		HDC 		hDC;
		PAINTSTRUCT ps;
		hDC = BeginPaint(hWnd,&ps);
		if(g_pData){
			RECT rc;
			GetClientRect(hWnd, &rc);
			DrawText(hDC, g_pData, strlen(g_pData), &rc, DT_EDITCONTROL);
		}
		EndPaint(hWnd,&ps);
		return 0;
	case WM_CLOSE:
		if(g_pData){
			free(g_pData);
			g_pData = NULL;
		}
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
